import bb.cascades 1.2

Sheet {
    id: logSheet
    property alias logText: textArea.text
    Page {
        Container {
            verticalAlignment: VerticalAlignment.Fill
            horizontalAlignment: HorizontalAlignment.Fill
            topPadding: 10
            leftPadding: topPadding
            rightPadding: topPadding
            bottomPadding: topPadding
            
            layout: StackLayout {}                    
            
            Container {
                layout: StackLayout {orientation: LayoutOrientation.LeftToRight}                    
                Button {
                    text: qsTr("Close") + Retranslate.onLocaleOrLanguageChanged
                    onClicked: logSheet.close();
                    horizontalAlignment: HorizontalAlignment.Fill
                }
                Container {
                    leftPadding: 100
                    horizontalAlignment: HorizontalAlignment.Fill
                    Button {
                        text: qsTr("Clear log") + Retranslate.onLocaleOrLanguageChanged
                        onClicked: {
                            _logger.clearLog();
                            textArea.text = _logger.getLog();
                        }
                    }                    
                }
            }
            ScrollView {
                Container {
                    topPadding: 50
                    verticalAlignment: VerticalAlignment.Fill
                    horizontalAlignment: HorizontalAlignment.Fill
                    TextArea {
                        id: textArea
                        editable: false
                    }
                }
                accessibility.description: "Scrolling"
                accessibility.name: "logScrollView"
            }
        }
    }
}    
