import bb.cascades 1.2
import bb.system 1.2

Sheet {
    id: settingsSheet
    Page {
        Container {                    
            layout: StackLayout {}
            Container {
                topPadding: 10
                leftPadding: topPadding
                rightPadding: topPadding
                bottomPadding: topPadding
                horizontalAlignment: HorizontalAlignment.Fill;
                Button {
                    text: qsTr("Close") + Retranslate.onLocaleOrLanguageChanged
                    onClicked: settingsSheet.close()
                    horizontalAlignment: HorizontalAlignment.Fill
                
                }
            }
            ScrollView {
                Container {
                    id: mainContainer
                    attachedObjects: [
                        LayoutUpdateHandler {
                            id: layoutHandler
                        }
                    ]
                    topPadding: 10
                    leftPadding: 30
                    rightPadding: leftPadding
                    bottomPadding: topPadding
                    verticalAlignment: VerticalAlignment.Fill
                    horizontalAlignment: HorizontalAlignment.Fill
                    Header {
                        title: qsTr("Scan for Viruses") + Retranslate.onLocaleOrLanguageChanged
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                        horizontalAlignment: HorizontalAlignment.Fill
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanDevice
                                checked: _app.getValueFor("scanDevice", "true")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanDevice", checked.toString())
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Device") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanSDCard
                                checked: _app.getValueFor("scanSDCard", "true")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanSDCard", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("SD Card") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                    
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                        horizontalAlignment: HorizontalAlignment.Fill
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanDropbox
                                checked: _app.getValueFor("scanDropbox", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanDropbox", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Dropbox") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanBox
                                checked: _app.getValueFor("scanBox", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanBox", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Box") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                        horizontalAlignment: HorizontalAlignment.Fill
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanOneDrive
                                checked: _app.getValueFor("scanOneDrive", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanOneDrive", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("OneDrive") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                    
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                        horizontalAlignment: HorizontalAlignment.Fill
                        bottomPadding: 30
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanComputers
                                checked: _app.getValueFor("scanComputers", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("scanComputers", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Scan Linked Devices (very slow)") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                    }
                    Header {
                        title: qsTr("Scanning Options") + Retranslate.onLocaleOrLanguageChanged
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.TopToBottom}
                        bottomPadding: 30
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: dontRescan
                                checked: _app.getValueFor("dontRescan", "true")
                                onCheckedChanged: _app.saveValueFor("dontRescan", checked.toString())
                            }
                            Label {
                                            
                                text: qsTr("Only rescan files when definitions or data changes") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: dontRescanForce
                                checked: _app.getValueFor("dontRescanForce", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("dontRescanForce", checked.toString())
                                    if (checked == true) {
                                        dontRescan.checked = true;
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Only rescan files when data changes") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        
                        //dontRescanForce
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            //                            visible: false
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: skipPicturesMusic
                                checked: _app.getValueFor("skipPicturesMusic", "false")
                                onCheckedChanged: _app.saveValueFor("skipPicturesMusic", checked.toString())
                            }
                            Label {
                                text: qsTr("Skip pictures and music files") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: fastScan
                                checked: _app.getValueFor("fastScan", "true")
                                onCheckedChanged: _app.saveValueFor("fastScan", checked.toString())
                            }
                            Label {
                                text: qsTr("Quick scan") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: skipLargeFiles
                                checked: _app.getValueFor("skipLargeFiles", "false")
                                onCheckedChanged: _app.saveValueFor("skipLargeFiles", checked.toString())
                            }
                            Label {
                                text: qsTr("Skip files larger than 1 Mb") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: skipCache
                                checked: _app.getValueFor("skipCache", "true")
                                onCheckedChanged: _app.saveValueFor("skipCache", checked.toString())
                            }
                            Label {
                                text: qsTr("Skip cache files") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: scanCloudWifi
                                checked: _app.getValueFor("scanCloudWifi", "true")
                                onCheckedChanged: _app.saveValueFor("scanCloudWifi", checked.toString())
                            }
                            Label {
                                text: qsTr("Only scan cloud files on wifi") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: keepAwake
                                checked: _app.getValueFor("keepAwake", "true")
                                onCheckedChanged: {
                                    _app.saveValueFor("keepAwake", checked.toString())
                                }
                            }
                            Label {
                                text: qsTr("Keep device awake (fullscreen only)") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: enableLogger
                                checked: _app.getValueFor("enableLogger", "false")
                                onCheckedChanged: {
                                    _app.saveValueFor("enableLogger", checked.toString())
                                }
                            }
                            Label {
                                text: qsTr("Enable logging") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        //keepAwake.checked = _app.getValueFor("keepAwake","true")
                        //Application.mainWindow.screenIdleMode = 1
                    }
                    Header {
                        title: qsTr("Headless Options") + Retranslate.onLocaleOrLanguageChanged
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.TopToBottom}
                        bottomPadding: 30
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: checkForUpdates
                                checked: _app.getValueFor("checkForUpdates", "true")
                                onCheckedChanged: _app.saveValueFor("checkForUpdates", checked.toString())
                            }
                            Label {
                                text: qsTr("Check for updates every day") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: remindMe
                                checked: _app.getValueFor("remindMe", "true")
                                onCheckedChanged: _app.saveValueFor("remindMe", checked.toString())
                            }
                            Label {
                                text: qsTr("Remind me to scan once a week") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: remindOnNewFile
                                checked: _app.getValueFor("remindOnNewFile", "true")
                                onCheckedChanged: {
                                    _app.saveValueFor("remindOnNewFile", checked.toString());
                                    if (checked)
                                        _app.sendToHL("startFileSystemWatcher");
                                    else
                                        _app.sendToHL("stopFileSystemWatcher");
                                }
                            }
                            Label {
                                text: qsTr("Tell me to scan new files") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            CheckBox {
                                id: ignoreMiscAndroid
                                checked: _app.getValueFor("ignoreMiscAndroid", "true")
                                onCheckedChanged: {
                                    _app.saveValueFor("ignoreMiscAndroid", checked.toString());
                                    if (_app.getValueFor("remindOnNewFile","true"))
                                    {
                                        _app.sendToHL("startFileSystemWatcher");
                                    }
                                }
                            }
                            Label {
                                text: qsTr("Don't monitor misc folder") + Retranslate.onLocaleOrLanguageChanged
                            }
                        }
                        Container {
                            topPadding: 10
                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2))
                            horizontalAlignment: HorizontalAlignment.Left
                            Label {
                                text: qsTr("Reminder: We cannot scan in headless mode.  This application needs to be running as in an Active Frame or Full Screen (faster) in order to virus scan your device.") + Retranslate.onLocaleOrLanguageChanged
                                multiline: true
                                horizontalAlignment: HorizontalAlignment.Center
                                textStyle.textAlign: TextAlign.Justify
                            }
                        }
                    }
                    Header {
                        title: qsTr("Reset") + Retranslate.onLocaleOrLanguageChanged
                    }
                    Container {
                        layout: StackLayout {orientation: LayoutOrientation.TopToBottom}
                        bottomPadding: 30
                        Container {
                            //                            minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2)) / 2
                            topPadding: 10
                            layout: StackLayout {orientation: LayoutOrientation.LeftToRight}
                            Button {
                                text: qsTr("Reset Whitelist") + Retranslate.onLocaleOrLanguageChanged
                                onClicked: resetWhitelistDialog.show()
                            }
                            Button {
                                text: qsTr("Reset All") + Retranslate.onLocaleOrLanguageChanged
                                onClicked: resetAllDialog.show()
                            }
                        }
                    }
                    Container {
                        minWidth: (layoutHandler.layoutFrame.width - (mainContainer.leftPadding * 2))
                        horizontalAlignment: HorizontalAlignment.Left
                        Label {
                            text: "v. " + Application.applicationVersion.toString();
                            multiline: false
                            horizontalAlignment: HorizontalAlignment.Center
                            textStyle.textAlign: TextAlign.Justify
                        }
                    }
                }
                accessibility.description: "Scrolling"
                accessibility.name: "settingsScrollView"
            }
        }   
        attachedObjects: [
            SystemDialog {
                id: resetWhitelistDialog
                title: qsTr("Reset All Whitelisted Files?") + Retranslate.onLocaleOrLanguageChanged
                body: qsTr("Are You Sure You Want To Remove All Files From Whitelist?") + Retranslate.onLocaleOrLanguageChanged
                confirmButton.label: qsTr("Ok") + Retranslate.onLocaleOrLanguageChanged
                confirmButton.enabled: true
                cancelButton.label: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
                cancelButton.enabled: true
                onFinished: {
                    if (result == SystemUiResult.ConfirmButtonSelection) {
                        _app.reset("whitelist");
                        toast.body = qsTr("Whitelist Have Been Reset") + Retranslate.onLocaleOrLanguageChanged;
                        toast.show();
                    }
                }
            },
            SystemDialog {
                id: resetAllDialog
                title: qsTr("Reset All Settings?") + Retranslate.onLocaleOrLanguageChanged
                body: qsTr("Are You Sure You Want To Reset All Settings? This Will Also Delete All Files In Quarantine.") + Retranslate.onLocaleOrLanguageChanged
                confirmButton.label: qsTr("Ok") + Retranslate.onLocaleOrLanguageChanged
                confirmButton.enabled: true
                cancelButton.label: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
                cancelButton.enabled: true
                onFinished: {
                    if (result == SystemUiResult.ConfirmButtonSelection) {
                        _app.reset("all");
                        
                        scanDevice.checked = _app.getValueFor("scanDevice", "true");
                        scanSDCard.checked = _app.getValueFor("scanSDCard", "true");
                        scanDropbox.checked = _app.getValueFor("scanDropbox", "false");
                        scanBox.checked = _app.getValueFor("scanBox", "false");
                        scanOneDrive.checked = _app.getValueFor("scanOneDrive", "false")
                        dontRescan.checked = _app.getValueFor("dontRescan", "true");
                        dontRescanForce.checked = _app.getValueFor("dontRescanForce", "false")
                        skipPicturesMusic.checked = _app.getValueFor("skipPicturesMusic", "false");
                        fastScan.checked = _app.getValueFor("fastScan", "true");
                        skipLargeFiles.checked = _app.getValueFor("skipLargeFiles", "false");
                        checkForUpdates.checked = _app.getValueFor("checkForUpdates", "true");
                        remindMe.checked = _app.getValueFor("remindMe", "true");
                        remindOnNewFile.checked = _app.getValueFor("remindOnNewFile", "true");
                        ignoreMiscAndroid.check = _app.getValueFor("ignoreMiscAndroid", "true");
                        scanComputers.check = _app.getValueFor("scanComputers","false");
                        skipCache.checked = _app.getValueFor("skipCache","true")
                        scanCloudWifi.checked = _app.getValueFor("scanCloudWifi","true")
                        keepAwake.checked = _app.getValueFor("keepAwake","true")
                        enableLogger.checked = _app.getValueFor("enableLogger","false")
                        
                        toast.body = qsTr("All Settings Have Been Reset") + Retranslate.onLocaleOrLanguageChanged;
                        toast.show();
                    }
                    if (_app.getValueFor("remindOnNewFile","true"))
                    {
                        _app.sendToHL("startFileSystemWatcher");
                    }
                    else 
                    {
                        _app.sendToHL("stopFileSystemWatcher");
                    }
                }
            },
            SystemToast {
                id: toast
            }
        ]
    }    
    
}
