import bb.cascades 1.2

Sheet {
    id: cardSheet
    objectName: "m_cardSheet"
    Page {
        titleBar: TitleBar {
            // Localized text with the dynamic translation and locale updates support
            title: qsTr("Secure AntiVirus Pro") + Retranslate.onLocaleOrLanguageChanged
        }
        
        Container {
            layout: DockLayout {
            }
            
            Button {
                translationX: 400
                visible: _app.openedAsCard()
                onClicked: _app.sendCardDoneMessage("Done", "Clicked")
            }
            ImageView {
                imageSource: "asset:///images/ico/s_icon.png"
                maxHeight: 75.0
                preferredHeight: 75.0
                minHeight: 75.0
                minWidth: 75.0
                preferredWidth: 75.0
                maxWidth: 75.0
                translationX: 50.0
                translationY: 30.0
                accessibility.name: ""
                accessibility.description: "Logo"
            }
            Label {
                text: qsTr("Scan for Threats") + Retranslate.onLocaleOrLanguageChanged
                translationX: 150.0
                translationY: 50.0
                textStyle.fontWeight: FontWeight.Bold
                textFit.maxFontSizeValue: 8.0
                textFit.minFontSizeValue: 8.0
            }
            Button {
                id: startScanButton
                text: _app.startButtonText
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Top
                translationY: 150.0
                scaleX: 1.0
                minWidth: 700.0
                preferredWidth: 700.0
                maxWidth: 700.0
                onClicked: {
                    _app.startScan("allFiles");
                }
            }
            Button {
                id: updateDefinitionsButton
                visible: false
                text: qsTr("Update Definitions") + Retranslate.onLocaleOrLanguageChanged
                objectName: "m_updateDefinitionsButton"
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Top
                translationY: 250.0
                scaleX: 1.0
                minWidth: 700.0
                preferredWidth: 700.0
                maxWidth: 700.0
                onClicked: _app.showUpdateTab()
            }
            ProgressIndicator {
                id: fileIndicator
                value: _app.fileProgress
                translationY: 250.0
                horizontalAlignment: HorizontalAlignment.Center
                accessibility.name: "fileIndicatorAB"
                accessibility.description: "File Indicator"
                toValue: 100.0
            }
            ProgressIndicator {
                id: scanIndicator
                value: _app.scanProgress
                translationY: 275.0
                horizontalAlignment: HorizontalAlignment.Center
                accessibility.name: "scanIndicatorAB"
                accessibility.description: "Scan Indicator"
                toValue: 100.0
            }
            Container {
                rightPadding: 25
                leftPadding: rightPadding
                translationY: 300.0
                Label {
                    id: stateLabel
                    multiline: true;
                    text: _app.stateLabelText
                }
            }
        }        
    }
}