/* Copyright (c) 2013 BlackBerry Limited.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import bb.cascades 1.2
import bb.device 1.2

// This is the file used for the SceneCover shown when the application
// is running in minimized mode on the running apps page.
Container {    
    layout: StackLayout {}
    verticalAlignment: VerticalAlignment.Fill
    horizontalAlignment: HorizontalAlignment.Fill
//    preferredWidth: 319
//    preferredHeight: 437
    background: Color.Black
    topPadding: 10
    leftPadding: topPadding
    rightPadding: topPadding
    bottomPadding: topPadding
    attachedObjects: [
        LayoutUpdateHandler {
            id: layoutHandler
        },
        HardwareInfo {
            id: thisDevice
        }
    ]
    // Container for the Active Frame
    Container {
        id: scannerActiveContainer
        visible: !(_appCover.startButtonText == qsTr("Start Scan") + Retranslate.onLocaleOrLanguageChanged)
        Container {
            id: buttonAndProgressContainer
            layout: StackLayout { 
                orientation: {
                    if (thisDevice.isPhysicalKeyboardDevice)
                        LayoutOrientation.LeftToRight
                    else 
                        LayoutOrientation.TopToBottom
                }
            }        
            horizontalAlignment: HorizontalAlignment.Center
            verticalAlignment: VerticalAlignment.Center
            Button {
                id: startScanButton
                text: _appCover.startButtonText.substr(_appCover.startButtonText.indexOf("... ") + 4, 8)
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Top
            }
            Container {
                layout: StackLayout {}
                horizontalAlignment: HorizontalAlignment.Center
                verticalAlignment: VerticalAlignment.Center
                ProgressIndicator {
                    id: fileIndicator
                    value: _appCover.fileProgress
                    horizontalAlignment: HorizontalAlignment.Center
                    accessibility.name: "fileIndicatorAB"
                    accessibility.description: "File Indicator"
                    toValue: 100.0
                }
                ProgressIndicator {
                    id: scanIndicator
                    value: _appCover.scanProgress
                    horizontalAlignment: HorizontalAlignment.Center
                    accessibility.name: "scanIndicatorAB"
                    accessibility.description: "Scan Indicator"
                    toValue: 100.0
                }
            }            
        }
        Label {
            id: stateLabel
            multiline: true;
            textStyle.color: Color.White
            textStyle.fontSize: {
                if (thisDevice.isPhysicalKeyboardDevice)
                	FontSize.XXSmall;
                else 
                    FontSize.XSmall;
            }
            text: _appCover.stateLabelText
        }
    } // End of the Active Frame container
    Container {
        id: scannerNotActiveContainer
        visible: (_appCover.startButtonText == qsTr("Start Scan") + Retranslate.onLocaleOrLanguageChanged)
        layout: StackLayout {}
        verticalAlignment: VerticalAlignment.Center
        horizontalAlignment: HorizontalAlignment.Center
        ImageView {
            imageSource: "asset:///images/active/scan_off.png"
            scalingMethod: ScalingMethod.AspectFit
            horizontalAlignment: HorizontalAlignment.Center
        }
        Label {
            text: qsTr("Not Scanning") + Retranslate.onLocaleOrLanguageChanged
            textStyle.color: Color.Gray
            horizontalAlignment: HorizontalAlignment.Center
        }
    }
}
