import bb.cascades 1.2
import bb.system 1.2

Page {
    titleBar: TitleBar {
        // Localized text with the dynamic translation and locale updates support
        title: qsTr("Secure AntiVirus Pro") + Retranslate.onLocaleOrLanguageChanged
    }
    onCreationCompleted: _app.setModel(_app.model)
    Container {
        Container {
            topPadding: 30
            bottomPadding: 30
            layout: StackLayout {
                orientation: LayoutOrientation.LeftToRight
            }        
            Container {
                leftPadding: 30
                ImageView {
                    imageSource: "asset:///images/ico/s_icon.png"
                    preferredHeight: 75.0
                    preferredWidth: 75.0
                    accessibility.name: ""
                    accessibility.description: "Logo"
                }            
            }
            Container {
                leftPadding: 45
                verticalAlignment: VerticalAlignment.Center
                Label {
                    text: qsTr("Quarantine") + Retranslate.onLocaleOrLanguageChanged
                    textStyle.fontWeight: FontWeight.Bold
                    textFit.maxFontSizeValue: 8.0
                    textFit.minFontSizeValue: 8.0
                }            
            }
        }        
        
        Container {
            rightPadding: 20
            leftPadding: rightPadding
            bottomPadding: rightPadding
            Container { 
                id: listViewContainer
                verticalAlignment: VerticalAlignment.Fill
                horizontalAlignment: HorizontalAlignment.Fill                
                background: background.imagePaint
                attachedObjects: [
                    ImagePaintDefinition {
                        id: background
                        repeatPattern: RepeatPattern.XY
                        imageSource: "asset:///images/common/savpLogo.amd"
                    }
                ]
                layout: StackLayout {}
                ListView {
                    id: m_listView
                    dataModel: _app.model
                    
                    listItemComponents: ListItemComponent {
                        type: "item"
                        StandardListItem {
                            
                            title: (qsTr("Virus: ") + Retranslate.onLocaleOrLanguageChanged) + ListItemData.virusName
                            description: ListItemData.shortPath
                        }
                    }
                    
                    onTriggered: {
                        // When an item is selected, we push the recipe Page in the chosenItem file attribute.
                        var chosenItem = dataModel.data(indexPath);
                        systemDialog.body = chosenItem.originalPath;
                        systemDialog.show();
                    }
                }
            }
        }
    }
    
    actions: [                            
        // context items
 /*       InvokeActionItem {
            title: qsTr("Share") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_share.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "B" }, Shortcut { key: "b" }]
            query {
                mimeType: "text/plain"
                invokeActionId: "bb.action.SHARE"
            }
            
            onTriggered: {
                // share on BBM code
                data = qsTr("Secure AntiVirus for BlackBerry 10!  You may not need it, but one day you may be happy you have it.  Get it here: http://appworld.blackberry.com/webstore/content/34092890") + Retranslate.onLocaleOrLanguageChanged                
                //shareBBM();
            }   
        }, */
        ActionItem {
            title: qsTr("Whitelist And Restore All") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_restore.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "R" }, Shortcut { key: "r" }]
            
            onTriggered: systemDialog2.show()
        },
        ActionItem {
            title: qsTr("Delete All Files") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_delete.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "D" }, Shortcut { key: "d" }]
            
            onTriggered: {
                _app.deleteFromQuarantine("*.*");
            }   
        },
        ActionItem {
            title: qsTr("Share") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_share.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "B" }, Shortcut { key: "b" }]
            
            onTriggered: {
                shareQuery.trigger("bb.action.SHARE")
            }   
        }
        ,
        ActionItem {
            title: qsTr("Report Bug") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_bug.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "R" }, Shortcut { key: "r" }]
                        
            onTriggered: {
                bugDialog.show();
            }
        },
        ActionItem {
            title: qsTr("Known Bugs") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_bugn.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "K" }, Shortcut { key: "K" }]
            
            onTriggered: {
                _downloadManager.getBugsOnline("http://www.filearchivehaven.com/data/AV3/bugs")
            }
        },
        
        ActionItem {
            title: qsTr("Write Review") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_review.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "W" }, Shortcut { key: "w" }]                    
            onTriggered: {
                reviewDialog.show()
            }
        }
    
    ]
    
    attachedObjects: [      
        SystemDialog {
            id: systemDialog
            title: qsTr("What Do You Want To Do With...") + Retranslate.onLocaleOrLanguageChanged
            confirmButton.label: qsTr("Whitelist And Restore") + Retranslate.onLocaleOrLanguageChanged
            confirmButton.enabled: true
            customButton.label: qsTr("Delete") + Retranslate.onLocaleOrLanguageChanged
            cancelButton.label: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
            cancelButton.enabled: true
            onFinished: {
                if (result == SystemUiResult.ConfirmButtonSelection) {
                    _app.restoreFromQuarantine(body);
                }
                if (result == SystemUiResult.CustomButtonSelection) {
                    _app.deleteFromQuarantine(body);
                }
            }
        },
        SystemDialog {
            id: systemDialog2
            title: qsTr("Whitelist And Restore All") + Retranslate.onLocaleOrLanguageChanged
            confirmButton.label: qsTr("Whitelist And Restore") + Retranslate.onLocaleOrLanguageChanged
            confirmButton.enabled: true
            cancelButton.label: qsTr("Cancel") + Retranslate.onLocaleOrLanguageChanged
            cancelButton.enabled: true
            onFinished: {
                if (result == SystemUiResult.ConfirmButtonSelection) {
                    _app.restoreFromQuarantine("*.*");
                }
            }
        },
        SystemDialog {
            id: reviewDialog
            title: qsTr("Leave Review") + Retranslate.onLocaleOrLanguageChanged
            body: qsTr("I need your help to keep making this application great!  If you experience any issues, please try contacting me before leaving a negative review (so I can fix the problem).  Please be honest in your review, but keep in mind that positive reviews means more users (and ultimately more improvements).") + Retranslate.onLocaleOrLanguageChanged 
            onFinished: {
                if (reviewDialog.result == SystemUiResult.ConfirmButtonSelection) {
                    reviewQuery.trigger("bb.action.OPEN")
                }
            }
        },
        Invocation {
            id: reviewQuery
            query {
                mimeType: "text/html"
                invokeTargetId:  "sys.appworld"
                uri: "appworld://content/34092890"
            }                   
        },
        SystemDialog {
            id: bugDialog
            title: qsTr("Report Bug") + Retranslate.onLocaleOrLanguageChanged
            body: qsTr("When reporting a bug, please include:  Any steps you remember to reproduce the bug, what you expected to happen, and what REALLY happened!") + Retranslate.onLocaleOrLanguageChanged              
            
            onFinished: {
                if (bugDialog.result == SystemUiResult.ConfirmButtonSelection) {
                    bugQuery.trigger("bb.action.SENDEMAIL");
                }
            }
        },
        Invocation {
            id: bugQuery
            query {
                mimeType: "text/plain"
                invokeTargetId: "sys.pim.uib.email.hybridcomposer"
                uri: "mailto:support@filearchivehaven.com?subject=Bug%20Report%20SecureAntiVirusPro%20" + Application.applicationVersion
            }                   
        },
        Invocation {
            id: shareQuery
            query {
                mimeType: "text/plain"
                data: qsTr("Secure AntiVirus Pro for BlackBerry 10!  You may not need it, but one day you may be happy you have it.  Get it here: http://appworld.blackberry.com/webstore/content/34092890") + Retranslate.onLocaleOrLanguageChanged      
            }
        }
    ]
}