import bb.cascades 1.2

Page {
    titleBar: TitleBar {
        // Localized text with the dynamic translation and locale updates support
        title: qsTr("Secure AntiVirus Pro") + Retranslate.onLocaleOrLanguageChanged
    }
    onCreationCompleted: {
//        _app.connectToQmlObject(updateProgressIndicator, "updateProgressIndicator")
//        _app.connectToQmlObject(updateButton, "updateButton")
//        _app.connectToQmlObject(versionLabel, "versionLabel")
        _downloadManager.updateFromUrl("http://www.filearchivehaven.com/data/AV3/current")
        _app.updateVersionLabel()
    }
    Container {
        layout: DockLayout {
        }
        
        ImageView {
            imageSource: "asset:///images/ico/s_icon.png"
            maxHeight: 75.0
            preferredHeight: 75.0
            minHeight: 75.0
            minWidth: 75.0
            preferredWidth: 75.0
            maxWidth: 75.0
            translationX: 50.0
            translationY: 30.0
            accessibility.name: ""
            accessibility.description: "Logo"
        }
        Label {
            text: qsTr("Check for Updates") + Retranslate.onLocaleOrLanguageChanged
            translationX: 150.0
            translationY: 50.0
            textStyle.fontWeight: FontWeight.Bold
            textFit.maxFontSizeValue: 8.0
            textFit.minFontSizeValue: 8.0
        }
        ScrollView {
            accessibility.name: "Scroll View"
            accessibility.description: "Scroll View"
            
            horizontalAlignment: HorizontalAlignment.Center
            
            Container { 
                verticalAlignment: VerticalAlignment.Fill
                horizontalAlignment: HorizontalAlignment.Fill                
                topPadding: 150
                
                layout: StackLayout {}  
                
                Button {
                    id: updateButton
                    enabled: false;
                    //enabled: _app.getValueFor("signatureVersion", "0.0.0.0") != _app.getValueFor("latestSignatureVersionOnline", "")
                    horizontalAlignment: HorizontalAlignment.Center
                    scaleX: 1.0
                    minWidth: 700.0
                    preferredWidth: 700.0
                    maxWidth: 700.0
                    text: qsTr("Update") + Retranslate.onLocaleOrLanguageChanged
                    onClicked: {
                        updateButton.enabled = false;
                        updateProgressIndicator.resetValue()
                        _downloadManager.updateFromUrl("http://filearchivehaven.com/data/AV3/sig.dat")
                    }                    
                }
                
                ProgressIndicator {
                    id: updateProgressIndicator                    
                    objectName: "m_updateProgressIndicator"
                    value: _app.updateProgress
                    horizontalAlignment: HorizontalAlignment.Center
                    preferredWidth: 700.0
                    maxWidth: 700.0
                    accessibility.name: "Progress Indicator"
                    accessibility.description: "Progress Indicator for Updates"
                    toValue: 100.0
                    onProgressChanged: {
                    }                    
                }
                Label {
                    id: versionLabel
                    multiline: true
                    text: _app.versionLabelText
                    onTextChanged: updateButton.enabled = _app.getValueFor("signatureVersion", "0.0.0.0") != _app.getValueFor("latestSignatureVersionOnline", "")
                }
            }
        }            
    
    }
    
    actions: [                            
        // context items
        ActionItem {
            title: qsTr("Share") + Retranslate.onLocaleOrLanguageChanged
            imageSource: "images/ico/a_share.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            shortcuts: [ Shortcut { key: "B" }, Shortcut { key: "b" }]

            onTriggered: {
                shareQuery.trigger("bb.action.SHARE")
            }   
        }
    ]
    attachedObjects: [      
        Invocation {
            id: shareQuery
            query {
                mimeType: "text/plain"
                data: qsTr("Secure AntiVirus Pro for BlackBerry 10!  You may not need it, but one day you may be happy you have it.  Get it here: http://appworld.blackberry.com/webstore/content/34092890") + Retranslate.onLocaleOrLanguageChanged      
            }
        }

    ]
}
